## percona-xtradb-cluster-5.6 5.6.43-28.32

=== debian/changelog ===
percona-xtradb-cluster-5.6 (5.6.43-28.32-1) unstable; urgency=medium

  * Update to new upstream release Percona XtraDB Cluster 5.6.43-rel84.3-
    28.32

 -- Percona Jenkins <jenkins@os-jessie-32-template>  Wed, 20 Feb 2019 17:09:50 -0500

percona-xtradb-cluster-5.6 (5.6.43-rel84.3) unstable; urgency=low

  * Packaging updates for PXC 5.6.

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Sun, 15 Feb 2015 08:28:27 +0200

=== debian/control ===
Source: percona-xtradb-cluster-5.6
Section: database
Priority: extra
Maintainer: Percona Server Development Team <mysql-dev@percona.com>
Uploaders: George Lorch <george.lorch@percona.com>,
           Tomislav Plavcic <tomislav.plavcic@percona.com>
           Raghavendra Prabhu <raghavendra.prabhu@percona.com>
Build-Depends: libtool (>= 1.4.2-7),
               procps,
               debhelper (>= 7.0.50~),
               file (>= 3.28),
               libncurses5-dev (>= 5.0-6),
               perl (>= 5.6.0),
               libwrap0-dev (>= 7.6-8.3),
               zlib1g-dev (>= 1:1.1.3-5),
               libreadline-dev,
               psmisc,
               po-debconf,
               chrpath,
               ghostscript,
               gawk,
               bison,
               lsb-release,
               cmake,
               gcc (>= 4.4),
               g++ (>= 4.4),
               libaio-dev[linux-any],
               libpam-dev,
               libssl-dev,
               libnuma-dev
Standards-Version: 7.0.0
Homepage: http://www.percona.com/software/percona-xtradb-cluster/
Vcs-Git: https://github.com/percona/percona-xtradb-cluster

Package: libperconaserverclient18.1
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: libmysqlclient18.1
Replaces: libpercona-server-client16, libperconaserverclient18
Description: Percona XtraDB Cluster database client library
 Percona XtraDB Cluster is based on the Percona Server database
 server and provides a High Availability solution.
 Percona XtraDB Cluster provides synchronous replication, supports
 multi-master replication, parallel applying on slaves, automatic
 node provisioning with primary focus on data consistency.
 .
 This package includes the client library.

Package: libperconaserverclient18.1-dev
Architecture: any
Section: libdevel
Depends: libperconaserverclient18.1 (= ${binary:Version}),
         zlib1g-dev, ${misc:Depends}
Breaks: libperconaserverclient18-dev,
        libperconaserverclient16-dev,
        libperconaserverclient15-dev,
        libperconaserverclient14-dev,
        libperconaserverclient12-dev,
        libperconaserverclient10-dev,
        libmysqlclient-dev,
        libmysqlclient18-dev,
        libmariadbclient-dev
Replaces: libperconaserverclient18-dev,
          libperconaserverclient16-dev,
          libperconaserverclient15-dev,
          libperconaserverclient14-dev,
          libperconaserverclient12-dev,
          libperconaserverclient10-dev,
          libpercona-xtradb-client-dev,
          libmariadbclient-dev
Provides: libmysqlclient-dev
Description: Percona XtraDB Cluster database development files
 Percona XtraDB Cluster is based on the Percona Server database
 server and provides a High Availability solution.
 Percona XtraDB Cluster provides synchronous replication, supports
 multi-master replication, parallel applying on slaves, automatic
 node provisioning with primary focus on data consistency.
 .
 This package includes development libraries and header files.

Package: percona-xtradb-cluster-common-5.6
Section: database
Architecture: any
Depends: ${misc:Depends}
Provides: mysql-common
Description: Percona XtraDB Cluster database common files (e.g. /etc/mysql/my.cnf)
 Percona XtraDB Cluster is based on the Percona Server database
 server and provides a High Availability solution.
 Percona XtraDB Cluster provides synchronous replication, supports
 multi-master replication, parallel applying on slaves, automatic
 node provisioning with primary focus on data consistency.
 .
 This package includes files needed by all versions of the client library
 (e.g. /etc/mysql/my.cnf).

Package: percona-xtradb-cluster-client-5.6
Architecture: any
Depends: debianutils (>=1.6),
         libdbi-perl,
         percona-xtradb-cluster-common-5.6 (>= ${source:Version}), 
         ${shlibs:Depends},
         ${misc:Depends}
Provides: mysql-client,
          virtual-mysql-client,
          virtual-mysql-client-core
Breaks: mysql-client-5.0,
        mysql-client-core-5.1,
        mysql-client-core-5.5,
        mysql-client-5.1,
        mysql-client-5.5,
        mysql-client-5.6,
        percona-xtradb-client-5.0,
        percona-server-client-5.1,
        percona-server-client-5.5,
        percona-xtradb-cluster-client-5.5,
        mariadb-client,
        mariadb-client-core-5.5,
        mariadb-client-5.5,
        virtual-mysql-client,
        virtual-mysql-client-core
Replaces: mysql-client-5.0,
           mysql-client-core-5.1,
           mysql-client-core-5.5,
           mysql-client-5.1,
           mysql-client-5.5,
           mysql-client-5.6,
           percona-xtradb-client-5.0,
           percona-server-client-5.1,
           percona-server-client-5.5,
           percona-xtradb-cluster-client-5.5,
           mariadb-client,
           mariadb-client-core-5.5,
           mariadb-client-5.5,
           virtual-mysql-client,
           virtual-mysql-client-core
Description: Percona XtraDB Cluster database client binaries
 Percona XtraDB Cluster is based on the Percona Server database
 server and provides a High Availability solution.
 Percona XtraDB Cluster provides synchronous replication, supports
 multi-master replication, parallel applying on slaves, automatic
 node provisioning with primary focus on data consistency.
 .
 This package includes the client binaries.

Package: percona-xtradb-cluster-server-5.6
Architecture: any
Suggests: tinyca, netcat-openbsd, pv, qpress
Pre-Depends: percona-xtradb-cluster-common-5.6 (>= ${source:Version}),
             adduser (>= 3.4.0),
             debconf
Depends: percona-xtradb-cluster-client-5.6 (>= ${source:Version}),
         libdbi-perl,
         libdbd-mysql-perl,
         perl (>= 5.6),
         ${shlibs:Depends},
         ${misc:Depends},
         psmisc,
         passwd,
         lsb-base (>= 3.0-10),
         percona-xtradb-cluster-galera-3 (= 3.32-1),
         percona-xtrabackup (>= 2.2.5),
         socat,
        lsof,
         rsync,
         iproute
Provides: mysql-server,
          virtual-mysql-server,
          virtual-mysql-server-core
Breaks: mysql-server-5.0,
        mysql-server-5.1,
        mysql-server-5.5,
        mysql-server-5.6,
        mysql-server-core-5.1,
        mysql-server-core-5.5,
        percona-xtradb-server-5.0,
        percona-server-server-5.1,
        percona-server-server-5.5,
        percona-xtradb-cluster-server-5.5,
        mariadb-server,
        mariadb-server-core-5.5,
        mariadb-server-5.5,
        virtual-mysql-server,
        virtual-mysql-server-core
Replaces: mysql-server-5.0,
          mysql-server-5.1,
          mysql-server-5.5,
          mysql-server-5.6,
          mysql-server-core-5.1,
          mysql-server-core-5.5,
          percona-xtradb-server-5.0,
          percona-server-server-5.1,
          percona-server-server-5.5,
          percona-xtradb-cluster-server-5.5,
          mariadb-server,
          mariadb-server-core-5.5,
          mariadb-server-5.5,
          virtual-mysql-server,
          virtual-mysql-server-core
Description: Percona XtraDB Cluster database server binaries
 Percona XtraDB Cluster is based on the Percona Server database
 server and provides a High Availability solution.
 Percona XtraDB Cluster provides synchronous replication, supports
 multi-master replication, parallel applying on slaves, automatic
 node provisioning with primary focus on data consistency.
 .
 This package includes the server binaries.


Package: percona-xtradb-cluster-server-debug-5.6
Architecture: any
Suggests: tinyca, netcat-openbsd, pv, qpress
Pre-Depends: percona-xtradb-cluster-common-5.6 (>= ${source:Version}),
             adduser (>= 3.4.0),
             debconf
Depends: percona-xtradb-cluster-client-5.6 (>= ${source:Version}),
         libdbi-perl,
         libdbd-mysql-perl,
         perl (>= 5.6),
         ${shlibs:Depends},
         ${misc:Depends},
         psmisc,
         passwd,
         lsb-base (>= 3.0-10),
         percona-xtradb-cluster-galera-3 (= 3.32-1),
         percona-xtrabackup (>= 2.2.5),
         socat,
         lsof,
         rsync,
         iproute
Provides: mysql-server-debug
Description: Percona XtraDB Cluster database server UNIV_DEBUG binaries
 Percona XtraDB Cluster is based on the Percona Server database
 server and provides a High Availability solution.
 Percona XtraDB Cluster provides synchronous replication, supports
 multi-master replication, parallel applying on slaves, automatic
 node provisioning with primary focus on data consistency.
 .
 This package includes the server binaries.

Package: percona-xtradb-cluster-56
Section: database
Architecture: any
Depends: percona-xtradb-cluster-server-5.6 (>= ${source:Version}), percona-xtradb-cluster-client-5.6 (>= ${source:Version}), percona-xtradb-cluster-galera-3 (= 3.32-1), ${misc:Depends}
Description: Percona XtraDB Cluster with Galera
 This is a meta-package providing PXC56 server, client and galera-3.

Package: percona-xtradb-cluster-full-56
Section: database
Architecture: any
Depends: percona-xtradb-cluster-server-5.6 (>= ${source:Version}), percona-xtradb-cluster-client-5.6 (>= ${source:Version}), percona-xtradb-cluster-galera-3 (= 3.32-1), percona-xtradb-cluster-test-5.6 (>= ${source:Version}), percona-xtradb-cluster-5.6-dbg (>= ${binary:Version}),  percona-xtradb-cluster-garbd-3 (= 3.32-1), percona-xtradb-cluster-galera3-dbg (= 3.32-1), percona-xtradb-cluster-server-debug-5.6, ${misc:Depends}
Description: Percona XtraDB Cluster with Galera
 This is a meta-package providing PXC56 server, client, galera-3, test and debug packages.

Package: percona-xtradb-cluster-test-5.6
Architecture: any
Depends: percona-xtradb-cluster-client-5.6 (>= ${source:Version}), percona-xtradb-cluster-server-5.6 (>= ${source:Version})
Description: Percona XtraDB Cluster database test suite
 This package includes the Percona XtraDB Cluster test framework that provides 
 a means for verifying that Percona XtraDB Cluster and its client programs 
 operate according to expectations.

Package: percona-xtradb-cluster-5.6-dbg
Architecture: any
Section: debug
Depends: percona-xtradb-cluster-server-5.6 (= ${binary:Version}), ${misc:Depends}
Description: Debugging package for Percona XtraDB Cluster
 Percona XtraDB Cluster is based on the Percona Server database
 server and provides a High Availability solution.
 Percona XtraDB Cluster provides synchronous replication, supports
 multi-master replication, parallel applying on slaves, automatic
 node provisioning with primary focus on data consistency.
 .
 This package contains the debugging symbols for the Percona XtraDB Cluster binaries.

Package: percona-xtradb-cluster-source-5.6
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Percona XtraDB Cluster 5.6 source
 This package includes the source code to Percona XtraDB Cluster as configured before building.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1

PACKAGE=percona-xtradb-cluster-5.6
PS_VERSION_EXTRA = $(shell echo "Percona XtraDB Cluster (GPL), $(DEBVERSION)")

TMP=$(CURDIR)/debian/tmp/
TMPD=$(CURDIR)/debian/tmp-debug/
prefix=/usr

ARCH = $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ARCH_OS = $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
NCPU = $(shell grep -c processor /proc/cpuinfo)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

export MYSQL_BUILD_CC=$(DEB_HOST_GNU_TYPE)-gcc$(USE_THIS_GCC_VERSION)
export MYSQL_BUILD_CXX=$(DEB_HOST_GNU_TYPE)-g++$(USE_THIS_GCC_VERSION)

DEB_SOURCE_PACKAGE ?= $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION ?= $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION ?= $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION ?= $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_UPSTREAM_VERSION_MAJOR_MINOR := $(shell echo $(DEB_UPSTREAM_VERSION) | sed -r -n 's/^([0-9]+\.[0-9]+).*/\1/p')
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

EXPORTED_SOURCE_TARBALL = debian/percona-xtradb-cluster-source-5.6.tar.gz

DISTRIBUTION = $(shell lsb_release -i -s)

wsrep_version="28.32"
percona_server_version="84.3"
revision="e2908fe"
compilation_comment_debug="Percona XtraDB Cluster - Debug (GPL), Release rel$(percona_server_version), Revision $(revision), WSREP version $(wsrep_version)"
compilation_comment_release="Percona XtraDB Cluster (GPL), Release rel$(percona_server_version), Revision $(revision), WSREP version $(wsrep_version)"
server_suffix="-56"
prefix=/usr

MYSQL_SRC = $(shell pwd)

#MAKE_TEST_TARGET=test-mtr
ifneq ($(findstring fulltest,$(DEB_BUILD_OPTIONS)),)
# make test-bt is the testsuite run by the MySQL build team 
# before a release, but it is long
    MAKE_TEST_TARGET=test-bt
endif

USE_ASSEMBLER=--enable-assembler 

ifneq (,$(filter $(ARCH), amd64 i386))
    TESTSUITE_FAIL_CMD=exit 1
else
    TESTSUITE_FAIL_CMD=true
endif

builddir = builddir
builddebug = debug

configure: patch configure-stamp

configure-stamp:
	@echo "RULES.$@"
	dh_testdir

ifneq ($(ARCH_OS),hurd)
	if [ ! -d /proc/self ]; then echo "/proc IS NEEDED" 1>&2; exit 1; fi 
endif

# Removed optimization flag for debug build - BLD-238 - bug1408232
ifeq ($(SKIP_DEBUG_BINARY),)
	( test -d $(builddebug) || mkdir $(builddebug) ) && cd $(builddebug) && \
	sh -c  'PATH=$${MYSQL_BUILD_PATH:-"/bin:/usr/bin"} \
	    	CC=$${MYSQL_BUILD_CC:-gcc} \
		CFLAGS=$${MYSQL_BUILD_CFLAGS:-"-g -fno-strict-aliasing"} \
	    	CXX=$${MYSQL_BUILD_CXX:-g++} \
		CXXFLAGS=$${MYSQL_BUILD_CXXFLAGS:-"-g -felide-constructors -fno-rtti -fno-strict-aliasing"} \
		cmake -DCMAKE_INSTALL_PREFIX=/usr \
		-DBUILD_CONFIG=mysql_release \
		-DMYSQL_UNIX_ADDR=/var/run/mysqld/mysqld.sock \
		-DCMAKE_BUILD_TYPE=Debug \
		-DWITH_LIBWRAP=ON \
		-DWITH_ZLIB=system \
		-DWITH_SSL=system \
		-DWITH_READLINE=system \
		-DWITHOUT_TOKUDB=ON \
		-DCOMPILATION_COMMENT=$(compilation_comment_debug) \
		-DMYSQL_SERVER_SUFFIX=$(server_suffix) \
		-DSYSTEM_TYPE="debian-linux-gnu" \
		-DINSTALL_LAYOUT=RPM \
		-DWITH_INNODB_DISALLOW_WRITES=ON \
		-DWITH_WSREP=ON \
		-DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \
		-DINSTALL_PLUGINDIR=lib/mysql/plugin/debug \
		-DWITH_EMBEDDED_SERVER=OFF \
		-DWITH_INNODB_MEMCACHED=ON \
		-DWITH_ARCHIVE_STORAGE_ENGINE=ON \
		-DWITH_BLACKHOLE_STORAGE_ENGINE=ON \
		-DWITH_FEDERATED_STORAGE_ENGINE=ON \
		-DWITH_PAM=ON \
                -DWITH_ROCKSDB=0 \
                -DWITH_SCALABILITY_METRICS=ON \
		-DWITH_EXTRA_CHARSETS=all $(TOKUDB_OPTS_DEBUG) ..'
endif

	( test -d $(builddir) || mkdir $(builddir) ) && cd $(builddir) && \
	sh -c  'PATH=$${MYSQL_BUILD_PATH:-"/bin:/usr/bin"} \
	    	CC=$${MYSQL_BUILD_CC:-gcc} \
	    	CFLAGS=$${MYSQL_BUILD_CFLAGS:-"-O3 -g -fno-strict-aliasing"} \
	    	CXX=$${MYSQL_BUILD_CXX:-g++} \
	    	CXXFLAGS=$${MYSQL_BUILD_CXXFLAGS:-"-O3 -g -felide-constructors -fno-rtti -fno-strict-aliasing"} \
	    cmake -DCMAKE_INSTALL_PREFIX=/usr \
		-DBUILD_CONFIG=mysql_release \
		-DMYSQL_UNIX_ADDR=/var/run/mysqld/mysqld.sock \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DWITH_LIBWRAP=ON \
		-DWITH_ZLIB=system \
		-DWITH_SSL=system \
		-DWITH_READLINE=system \
		-DWITHOUT_TOKUDB=ON \
		-DCOMPILATION_COMMENT=$(compilation_comment_release) \
		-DMYSQL_SERVER_SUFFIX=$(server_suffix) \
		-DSYSTEM_TYPE="debian-linux-gnu" \
		-DINSTALL_LAYOUT=RPM \
		-DWITH_INNODB_DISALLOW_WRITES=ON \
		-DWITH_WSREP=ON \
		-DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \
		-DINSTALL_PLUGINDIR=lib/mysql/plugin \
		-DWITH_EMBEDDED_SERVER=OFF \
		-DWITH_INNODB_MEMCACHED=ON \
		-DWITH_ARCHIVE_STORAGE_ENGINE=ON \
		-DWITH_BLACKHOLE_STORAGE_ENGINE=ON \
		-DWITH_FEDERATED_STORAGE_ENGINE=ON \
		-DWITH_PAM=ON \
                -DWITH_ROCKSDB=0 \
                -DWITH_SCALABILITY_METRICS=ON \
		-DWITH_EXTRA_CHARSETS=all $(TOKUDB_OPTS_RELEASE) ..'
	touch $@

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: configure
	@echo "RULES.$@"
	dh_testdir
	
	[ -f $(EXPORTED_SOURCE_TARBALL) ] || tar -zcf $(EXPORTED_SOURCE_TARBALL) \
	--exclude=debian . \
	--transform="s,^\./,percona-xtradb-cluster-5.6/,"

ifeq ($(SKIP_DEBUG_BINARY),)
	cd $(builddebug) && $(MAKE) -j$(NCPU)  VERBOSE=1
endif

	cd $(builddir) && $(MAKE) -j$(NCPU) VERBOSE=1

ifeq ($(findstring nocheck,$(DEB_BUILD_OPTIONS)),)
	# Don't know why the following is necessary...
	cp -r mysql-test/* $(builddir)/mysql-test/
	cp -r sql/share/* $(builddir)/sql/share/
	cp -r scripts/*sql $(builddir)/scripts/
	if [ ! -f testsuite-stamp ] ; then \
	  (cd $(builddir) && $(MAKE) test-unit) || $(TESTSUITE_FAIL_CMD) ; \
	  cd $(builddir) && $(MAKE) $(MAKE_TEST_TARGET) || $(TESTSUITE_FAIL_CMD) ; \
	fi
endif

	touch testsuite-stamp

	touch build-stamp

clean: clean-patched
	rm -rf debian/patched

clean-patched:
	@echo "RULES.clean-patched"
	dh_testdir 
	dh_testroot
	rm -f configure-stamp*
	rm -f build-stamp*
	rm -f testsuite-stamp
	
	[ ! -f Makefile ] || $(MAKE) clean
	[ ! -d mysql-test/var ] || rm -rf mysql-test/var
	
	rm -rf $(builddir)
	rm -rf $(builddebug)

	debconf-updatepo
	# rm -f $(EXPORTED_SOURCE_TARBALL)
	dh_clean -v


install: build
	@echo "RULES.$@"
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# make install (trailing slash needed for innobase)
	(cd $(builddebug) && $(MAKE) install DESTDIR=$(TMPD)/)
	(cd $(builddir) && $(MAKE) install DESTDIR=$(TMP)/)

	# After installing, remove rpath to make lintian happy.
	set +e; \
	find ./debian/tmp/ -type f -print0 \
		| xargs -0 --no-run-if-empty chrpath -k 2>/dev/null \
		| fgrep RPATH= \
		| cut -d: -f 1 \
		| xargs --no-run-if-empty chrpath -d; \
	set -e

	# libmysqlclient: move shared libraries (but not the rest like libheap.a & co)
	# libmysqlclient_r is now a symlink to libmysqlclient. But it is
	# created wrong by the cmake build system and points at
	# libmysqlclient.so instead of the corresponding versioned lib.
	for i in `ls $(TMP)/usr/lib/$(DEB_HOST_MULTIARCH)/libmysqlclient.so*` ; do \
		rlib=`basename $$i | sed -e 's/libmysqlclient\./libmysqlclient_r./'` ;\
		ln -sf `basename $$i` $(TMP)/usr/lib/$(DEB_HOST_MULTIARCH)/$$rlib ;\
	done

	# libmysqlclient-dev: forgotten header file since 3.23.25?
	#cp $(BUILDDIR)/include/my_config.h $(TMP)/usr/include/mysql/
	#cp include/my_dir.h $(TMP)/usr/include/mysql/
	# install libmysqld built with -FPIC
	install -d -m 0755 -o root -g root $(TMP)/usr/lib/percona-xtradb-cluster
	#install -m 0644 -o root -g root $(BUILDDIR_PIC)/libmysqld/libmysqld.a $(TMP)/usr/lib/mysql/libmysqld_pic.a
	# mysql_config won't report the -fPIC, so give libmysqld-pic users a way to get their flags
	#install -m 0755 -o root -g root $(BUILDDIR_PIC)/scripts/mysql_config $(TMP)/usr/bin/mysql_config_pic

	# mysql-common: We now provide our own config file.
	install -d $(TMP)/etc/mysql

## percona-xtradb-cluster-5.6 5.6.44

=== extra/CMakeLists.txt ===
# Copyright (c) 2006, 2018, Oracle and/or its affiliates. All rights reserved.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/include 
# Following is for perror, in case NDB is compiled in.
${CMAKE_SOURCE_DIR}/storage/ndb/include
${CMAKE_SOURCE_DIR}/storage/ndb/include/util  
${CMAKE_SOURCE_DIR}/storage/ndb/include/ndbapi
${CMAKE_SOURCE_DIR}/storage/ndb/include/portlib
${CMAKE_SOURCE_DIR}/storage/ndb/include/mgmapi)

# Default install component for the files is Server here
SET(MYSQL_INSTALL_COMPONENT Server)

IF(NOT CMAKE_CROSSCOMPILING)
 ADD_EXECUTABLE(comp_err comp_err.c)
 TARGET_LINK_LIBRARIES(comp_err mysys mysys_ssl)
 SET_TARGET_PROPERTIES(comp_err PROPERTIES LINKER_LANGUAGE CXX)
ENDIF()


ADD_CUSTOM_COMMAND(OUTPUT ${PROJECT_BINARY_DIR}/include/mysqld_error.h 
                   ${PROJECT_BINARY_DIR}/sql/share/english/errmsg.sys
                   COMMAND comp_err
                    --charset=${PROJECT_SOURCE_DIR}/sql/share/charsets 
                    --out-dir=${PROJECT_BINARY_DIR}/sql/share/
                    --header_file=${PROJECT_BINARY_DIR}/include/mysqld_error.h 
                    --name_file=${PROJECT_BINARY_DIR}/include/mysqld_ername.h
                    --state_file=${PROJECT_BINARY_DIR}/include/sql_state.h
                    --in_file=${PROJECT_SOURCE_DIR}/sql/share/errmsg-utf8.txt
                   DEPENDS ${PROJECT_SOURCE_DIR}/sql/share/errmsg-utf8.txt
                   ${CMAKE_CURRENT_SOURCE_DIR}/comp_err.c)

ADD_CUSTOM_TARGET(GenError
                  ALL
                  DEPENDS 
                  ${PROJECT_BINARY_DIR}/include/mysqld_error.h
                  ${PROJECT_BINARY_DIR}/sql/share/english/errmsg.sys 
                  ${PROJECT_SOURCE_DIR}/sql/share/errmsg-utf8.txt)

## Most executables depend on libeay32.dll (through mysys_ssl).
## For 'comp_err' we need it to be available during build.
COPY_OPENSSL_DLLS(copy_openssl_extra)
IF (WIN32 AND WITH_SSL_PATH AND HAVE_CRYPTO_DLL)
  ADD_DEPENDENCIES(GenError copy_openssl_extra)
ENDIF()


MYSQL_ADD_EXECUTABLE(my_print_defaults my_print_defaults.c)
TARGET_LINK_LIBRARIES(my_print_defaults  mysys mysys_ssl)
SET_TARGET_PROPERTIES(my_print_defaults PROPERTIES LINKER_LANGUAGE CXX)

MYSQL_ADD_EXECUTABLE(perror perror.c)
ADD_DEPENDENCIES(perror GenError)
TARGET_LINK_LIBRARIES(perror mysys mysys_ssl)
SET_TARGET_PROPERTIES(perror PROPERTIES LINKER_LANGUAGE CXX)

MYSQL_ADD_EXECUTABLE(resolveip resolveip.c)
TARGET_LINK_LIBRARIES(resolveip mysys mysys_ssl)
SET_TARGET_PROPERTIES(resolveip PROPERTIES LINKER_LANGUAGE CXX)
IF(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
  INCLUDE(CheckFunctionExists)
  INCLUDE(CheckLibraryExists)
  MY_SEARCH_LIBS(inet_aton  "nsl;socket;resolv" SOLARIS_NSL)
  TARGET_LINK_LIBRARIES(resolveip ${SOLARIS_NSL})
ENDIF()


MYSQL_ADD_EXECUTABLE(replace replace.c)
TARGET_LINK_LIBRARIES(replace mysys)

IF(WITH_INNOBASE_STORAGE_ENGINE)
  # Add path to the InnoDB headers
  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/storage/innobase/include)
  # We use the InnoDB code directly in case the code changes.
  ADD_DEFINITIONS("-DUNIV_INNOCHECKSUM")
  SET(INNOBASE_SOURCES
      ../storage/innobase/buf/buf0checksum.cc
      ../storage/innobase/ut/ut0crc32.cc
      ../storage/innobase/ut/ut0ut.cc
      ../storage/innobase/page/page0page.cc
      ../storage/innobase/page/page0zip.cc
     )
  MYSQL_ADD_EXECUTABLE(innochecksum innochecksum.cc ${INNOBASE_SOURCES})
  TARGET_LINK_LIBRARIES(innochecksum mysys mysys_ssl)
  ADD_DEPENDENCIES(innochecksum GenError)
ENDIF()

IF(UNIX)
  MYSQL_ADD_EXECUTABLE(resolve_stack_dump resolve_stack_dump.cc)
  TARGET_LINK_LIBRARIES(resolve_stack_dump mysys mysys_ssl)

  MYSQL_ADD_EXECUTABLE(mysql_waitpid mysql_waitpid.c)
  TARGET_LINK_LIBRARIES(mysql_waitpid mysys mysys_ssl)
  SET_TARGET_PROPERTIES(mysql_waitpid PROPERTIES LINKER_LANGUAGE CXX)
ENDIF()

=== sql/CMakeLists.txt ===
# Copyright (c) 2006, 2019, Oracle and/or its affiliates. All rights reserved.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

INCLUDE_DIRECTORIES(
  ${CMAKE_SOURCE_DIR}/include 
  ${CMAKE_SOURCE_DIR}/sql 
  ${CMAKE_SOURCE_DIR}/regex 
  ${SSL_INCLUDE_DIRS}
  ${CMAKE_BINARY_DIR}/sql
  ${WSREP_INCLUDES}
)

SET(CONF_SOURCES
  ${CMAKE_CURRENT_BINARY_DIR}/sql_builtin.cc
)
SET(GEN_SOURCES
  ${CMAKE_CURRENT_BINARY_DIR}/sql_yacc.h 
  ${CMAKE_CURRENT_BINARY_DIR}/sql_yacc.cc
  ${CMAKE_CURRENT_BINARY_DIR}/lex_hash.h 
)
SET(GEN_DIGEST_SOURCES
  ${CMAKE_CURRENT_BINARY_DIR}/lex_token.h 
)

SET_SOURCE_FILES_PROPERTIES(${GEN_SOURCES}
                            ${GEN_DIGEST_SOURCES}
                            ${CONF_SOURCES}
                            PROPERTIES GENERATED 1)

# Gen_lex_token
# Make sure sql_yacc.h is generated before compiling gen_lex_token
ADD_EXECUTABLE(gen_lex_token gen_lex_token.cc)
ADD_DEPENDENCIES(gen_lex_token GenServerSource)

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/lex_token.h
  COMMAND gen_lex_token > lex_token.h
  DEPENDS gen_lex_token
)

ADD_DEFINITIONS(-DMYSQL_SERVER -DHAVE_EVENT_SCHEDULER -DHAVE_POOL_OF_THREADS)
IF(SSL_DEFINES)
 ADD_DEFINITIONS(${SSL_DEFINES})
ENDIF()

SET(SQL_SHARED_SOURCES
  abstract_query_plan.cc
  datadict.cc
  debug_sync.cc
  derror.cc
  des_key_file.cc
  discover.cc
  field.cc
  field_conv.cc 
  filesort.cc
  filesort_utils.cc
  gcalc_slicescan.cc
  gcalc_tools.cc
  gstream.cc
  handler.cc
  hostname.cc
  init.cc
  item.cc
  item_buff.cc
  item_cmpfunc.cc 
  item_create.cc
  item_func.cc
  item_geofunc.cc
  item_row.cc 
  item_strfunc.cc
  item_subselect.cc
  item_sum.cc
  item_timefunc.cc 
  item_xmlfunc.cc 
  item_inetfunc.cc
  key.cc
  keycaches.cc
  lock.cc
  log.cc
  mdl.cc
  mf_iocache.cc
  my_decimal.cc
  net_serv.cc
  opt_explain.cc
  opt_explain_traditional.cc
  opt_explain_json.cc
  opt_range.cc
  opt_sum.cc 
  opt_trace.cc
  opt_trace2server.cc
  parse_file.cc
  partition_info.cc
  password.c
  procedure.cc 
  protocol.cc
  records.cc
  rpl_handler.cc
  scheduler.cc 
  set_var.cc 
  signal_handler.cc
  sp.cc
  sp_cache.cc
  sp_head.cc
  sp_instr.cc
  sp_pcontext.cc 
  sp_rcontext.cc
  spatial.cc
  string_service.cc
  sql_acl.cc
  sql_admin.cc
  sql_alloc_error_handler.cc
  sql_alter.cc
  sql_analyse.cc
  sql_audit.cc
  sql_base.cc 
  sql_bootstrap.cc
  sql_cache.cc
  sql_class.cc
  sql_connect.cc
  sql_crypt.cc
  sql_cursor.cc
  sql_data_change.cc
  sql_db.cc
  sql_delete.cc
  sql_derived.cc
  sql_digest.cc
  sql_do.cc 
  sql_error.cc
  sql_executor.cc
  sql_get_diagnostics.cc
  sql_handler.cc
  sql_help.cc
  sql_insert.cc
  sql_join_buffer.cc
  sql_lex.cc 
  sql_list.cc
  sql_load.cc
  sql_locale.cc
  sql_manager.cc
  sql_optimizer.cc
  sql_parse.cc
  sql_partition.cc
  sql_partition_admin.cc
  sql_planner.cc
  sql_plugin.cc
  sql_prepare.cc
  sql_profile.cc
  sql_reload.cc
  sql_rename.cc
  sql_resolver.cc
  sql_rewrite.cc
  sql_select.cc
  sql_servers.cc
  sql_show.cc
  sql_signal.cc
  sql_state.c
  sql_string.cc 
  sql_table.cc
  sql_tablespace.cc
  sql_test.cc
  sql_time.cc
  sql_tmp_table.cc
  sql_trigger.cc
  sql_truncate.cc
  sql_udf.cc
  sql_union.cc
  sql_update.cc
  sql_view.cc
  sql_zip_dict.cc
  strfunc.cc
  sys_vars.cc
  table.cc
  table_cache.cc
  thr_malloc.cc 
  transaction.cc
  tztime.cc
  uniques.cc
  unireg.cc
  userstat.cc
  threadpool_common.cc
)

IF(WIN32)
  SET(SQL_SHARED_SOURCES ${SQL_SHARED_SOURCES} threadpool_win.cc)
ELSE()
 SET(SQL_SHARED_SOURCES ${SQL_SHARED_SOURCES} threadpool_unix.cc)
ENDIF()

SET(SQL_EXPORTED_SOURCES ${SQL_SHARED_SOURCES} PARENT_SCOPE)

IF(WITH_WSREP)
 SET(WSREP_SOURCES
   wsrep_utils.cc
   wsrep_xid.cc
   wsrep_check_opts.cc
   wsrep_hton.cc
   wsrep_mysqld.cc
   wsrep_notify.cc
   wsrep_sst.cc
   wsrep_var.cc
   wsrep_binlog.cc
   wsrep_applier.cc
   wsrep_thd.cc
 )
 SET(WSREP_LIB wsrep)
ENDIF()

SET(SQL_SOURCE
  ${WSREP_SOURCES}
  ${GEN_SOURCES}
  ${GEN_DIGEST_SOURCES}
  ${CONF_SOURCES}
  ${MYSYS_LIBWRAP_SOURCE}
  ${SQL_SHARED_SOURCES}
  ../libmysql/errmsg.c
  ../sql-common/client.c
  ../sql-common/client_plugin.c
  ../sql-common/my_path_permissions.cc
  ../sql-common/my_time.c
  ../sql-common/my_user.c 
  ../sql-common/pack.c
  ../sql-common/client_authentication.cc
  event_data_objects.cc
  event_db_repository.cc 
  event_parse_data.cc
  event_queue.cc
  event_scheduler.cc
  events.cc
  mysqld.cc
  sql_client.cc
  )

IF(WIN32)
  LIST(APPEND SQL_SOURCE named_pipe.cc)
ENDIF()

IF (WIN32 AND OPENSSL_APPLINK_C)
  SET_SOURCE_FILES_PROPERTIES(
    ../sql-common/client_authentication.cc
    PROPERTIES COMPILE_FLAGS "-DHAVE_OPENSSL_APPLINK_C"
  )
ENDIF()

IF(HAVE_MY_TIMER)
  SET(SQL_SOURCE ${SQL_SOURCE} sql_timer.cc)
ENDIF()

MYSQL_ADD_PLUGIN(partition ha_partition.cc STORAGE_ENGINE DEFAULT STATIC_ONLY
RECOMPILE_FOR_EMBEDDED)

ADD_LIBRARY(sql STATIC ${SQL_SOURCE})
ADD_DEPENDENCIES(sql GenServerSource)
ADD_DEPENDENCIES(sql GenDigestServerSource)
DTRACE_INSTRUMENT(sql)
TARGET_LINK_LIBRARIES(sql ${MYSQLD_STATIC_PLUGIN_LIBS} 
  mysys mysys_ssl dbug strings vio regex   
  ${LIBWRAP} ${LIBCRYPT} ${LIBDL}
  ${WSREP_LIB}
  ${SSL_LIBRARIES})

#
# On Windows platform we compile in the clinet-side Windows Native Authentication
# plugin which is used by the client connection code included in the server.
#
IF(WIN32)
  ADD_DEFINITIONS(-DAUTHENTICATION_WIN)
  TARGET_LINK_LIBRARIES(sql auth_win_client)
ENDIF()

SET (BINLOG_SOURCE uuid.cc rpl_gtid_misc.cc
                   rpl_gtid_sid_map.cc rpl_gtid_set.cc rpl_gtid_specification.cc
                   rpl_gtid_state.cc rpl_gtid_owned.cc rpl_gtid_cache.cc
                   rpl_gtid_execution.cc rpl_gtid_mutex_cond_array.cc
                   log_event.cc log_event_old.cc binlog.cc sql_binlog.cc
		   rpl_filter.cc rpl_record.cc rpl_record_old.cc rpl_utility.cc
		   rpl_injector.cc)
ADD_LIBRARY(binlog ${BINLOG_SOURCE})
SET (RPL_SOURCE rpl_handler.cc rpl_tblmap.cc)
ADD_DEPENDENCIES(binlog GenError)
ADD_LIBRARY(rpl ${RPL_SOURCE})
SET (MASTER_SOURCE rpl_master.cc)
ADD_DEPENDENCIES(rpl GenError)
ADD_LIBRARY(master ${MASTER_SOURCE})
ADD_DEPENDENCIES(master GenError)
SET (SLAVE_SOURCE rpl_slave.cc rpl_reporting.cc rpl_mi.cc rpl_rli.cc
		  rpl_info_handler.cc rpl_info_file.cc rpl_info_table.cc
		  rpl_info_values.cc rpl_info.cc rpl_info_factory.cc
		  rpl_info_table_access.cc dynamic_ids.cc rpl_rli_pdb.cc
		  rpl_info_dummy.cc)
ADD_LIBRARY(slave ${SLAVE_SOURCE})
ADD_DEPENDENCIES(slave GenError)
ADD_LIBRARY(sqlgunitlib
  filesort_utils.cc mdl.cc sql_list.cc sql_string.cc thr_malloc.cc
  )
ADD_DEPENDENCIES(sqlgunitlib GenError)


IF(WIN32)
  SET(MYSQLD_SOURCE main.cc nt_servc.cc nt_servc.h message.rc)
ELSE()
  SET(MYSQLD_SOURCE main.cc ${DTRACE_PROBES_ALL})
ENDIF()

MYSQL_ADD_EXECUTABLE(mysqld
  ${MYSQLD_SOURCE} DESTINATION ${INSTALL_SBINDIR} COMPONENT Server)

OPTION(DEBUG_EXTNAME "Build server as mysqld-debug (debug builds only)" OFF)
MARK_AS_ADVANCED(DEBUG_EXTNAME)

IF(DEBUG_EXTNAME)
  SET_TARGET_PROPERTIES(mysqld PROPERTIES DEBUG_OUTPUT_NAME "mysqld-debug")
ENDIF()

IF(APPLE) 
  # Add CoreServices framework since some dloadable plugins may need it 
  FIND_LIBRARY(CORESERVICES NAMES CoreServices) 
  IF(CORESERVICES) 
    TARGET_LINK_LIBRARIES(mysqld ${CORESERVICES}) 
  ENDIF() 
ENDIF() 

IF(NOT WITHOUT_DYNAMIC_PLUGINS)
  SET_TARGET_PROPERTIES(mysqld PROPERTIES ENABLE_EXPORTS TRUE)
  GET_TARGET_PROPERTY(mysqld_link_flags mysqld LINK_FLAGS)
  IF(NOT mysqld_link_flags)
    SET(mysqld_link_flags)
  ENDIF()
  IF (MINGW OR CYGWIN)
    SET_TARGET_PROPERTIES(mysqld PROPERTIES LINK_FLAGS "${mysqld_link_flags} -Wl,--export-all-symbols")
  ENDIF()
  IF(MSVC)
    # Set module definition file.
    # Also use non-incremental linker, incremental appears to crash from
    # time to time,if used with /DEF option
    SET_TARGET_PROPERTIES(mysqld PROPERTIES LINK_FLAGS
      "${mysqld_link_flags} /DEF:mysqld.def /INCREMENTAL:NO")

    FOREACH (CORELIB sql mysys mysys_ssl dbug strings)
      GET_TARGET_PROPERTY(LOC ${CORELIB} LOCATION)
      FILE(TO_NATIVE_PATH ${LOC} LOC)
      SET (LIB_LOCATIONS ${LIB_LOCATIONS} ${LOC}) 
    ENDFOREACH (CORELIB ${MYSQLD_CORE_LIBS})
    SET(_PLATFORM x86)
    IF(CMAKE_SIZEOF_VOID_P EQUAL 8)
      SET(_PLATFORM  x64)
    ENDIF()
    ADD_CUSTOM_COMMAND(TARGET mysqld PRE_LINK
      COMMAND echo ${_PLATFORM} && cscript ARGS //nologo ${PROJECT_SOURCE_DIR}/win/create_def_file.js
                  ${_PLATFORM}  ${LIB_LOCATIONS} > mysqld.def 
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    ADD_DEPENDENCIES(sql GenError)
  ENDIF()
ENDIF()

SET_TARGET_PROPERTIES(mysqld PROPERTIES ENABLE_EXPORTS TRUE) 
TARGET_LINK_LIBRARIES(mysqld sql binlog rpl master slave sql mysys mysys_ssl)

# Provide plugins with minimal set of libraries
SET(INTERFACE_LIBS ${LIBRT})
IF(INTERFACE_LIBS)
 SET_TARGET_PROPERTIES(mysqld PROPERTIES LINK_INTERFACE_LIBRARIES 
  "${INTERFACE_LIBS}")
ENDIF()

# On Solaris, some extra effort is required in order to get dtrace probes
# from static libraries
DTRACE_INSTRUMENT_STATIC_LIBS(mysqld 
 "sql;mysys;mysys_ssl;${MYSQLD_STATIC_PLUGIN_LIBS}")
 

SET(WITH_MYSQLD_LDFLAGS "" CACHE STRING "Additional linker flags for mysqld")
MARK_AS_ADVANCED(WITH_MYSQLD_LDFLAGS)
IF(WITH_MYSQLD_LDFLAGS)
  GET_TARGET_PROPERTY(mysqld LINK_FLAGS MYSQLD_LINK_FLAGS)
  IF(NOT MYSQLD_LINK_FLAGS)
    SET(MYSQLD_LINK_FLAGS) 
  ENDIF() 
  SET_TARGET_PROPERTIES(mysqld PROPERTIES LINK_FLAGS 
     "${MYSQLD_LINK_FLAGS} ${WITH_MYSQLD_LDFLAGS}")
ENDIF()

IF(DEBUG_EXTNAME)
  INSTALL_DEBUG_TARGET(mysqld 
    DESTINATION ${INSTALL_SBINDIR} 
    PDB_DESTINATION ${INSTALL_SBINDIR}
    SUFFIX "-debug")
ELSE()
  INSTALL_DEBUG_TARGET(mysqld 
    DESTINATION ${INSTALL_SBINDIR} 
    PDB_DESTINATION ${INSTALL_SBINDIR}/debug
    RENAME mysqld-debug)
ENDIF()

# Handle out-of-source build from source package with possibly broken 
# bison. Copy bison output to from source to build directory, if not already 
# there
INCLUDE(${CMAKE_SOURCE_DIR}/cmake/bison.cmake)
COPY_BISON_OUTPUT(
  ${CMAKE_CURRENT_SOURCE_DIR}/sql_yacc.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/sql_yacc.h
  ${CMAKE_CURRENT_BINARY_DIR}/sql_yacc.cc
  ${CMAKE_CURRENT_BINARY_DIR}/sql_yacc.h
)

RUN_BISON(
  ${CMAKE_CURRENT_SOURCE_DIR}/sql_yacc.yy 
  ${CMAKE_CURRENT_BINARY_DIR}/sql_yacc.cc
  ${CMAKE_CURRENT_BINARY_DIR}/sql_yacc.h
)

SET_SOURCE_FILES_PROPERTIES(
  ${CMAKE_CURRENT_BINARY_DIR}/sql_yacc.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/sql_digest.cc
  PROPERTIES OBJECT_DEPENDS ${GEN_DIGEST_SOURCES}
)

# Gen_lex_hash
ADD_EXECUTABLE(gen_lex_hash gen_lex_hash.cc)

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/lex_hash.h
  COMMAND gen_lex_hash > lex_hash.h
  DEPENDS gen_lex_hash
)

MYSQL_ADD_EXECUTABLE(mysql_tzinfo_to_sql tztime.cc)
SET_TARGET_PROPERTIES(mysql_tzinfo_to_sql PROPERTIES COMPILE_FLAGS "-DTZINFO2SQL")
TARGET_LINK_LIBRARIES(mysql_tzinfo_to_sql mysys mysys_ssl)

ADD_CUSTOM_TARGET( 
        GenServerSource
        DEPENDS ${GEN_SOURCES}
)

ADD_CUSTOM_TARGET( 
        GenDigestServerSource
        DEPENDS ${GEN_DIGEST_SOURCES}
)


MYSQL_ADD_PLUGIN(udf_example udf_example.cc
                 MODULE_ONLY TEST_ONLY MODULE_OUTPUT_NAME "udf_example")
IF(NOT DISABLE_SHARED)
  IF(WIN32)
    SET_TARGET_PROPERTIES(udf_example
      PROPERTIES LINK_FLAGS
      "/DEF:${CMAKE_CURRENT_SOURCE_DIR}/udf_example.def")
  ENDIF()
ENDIF()

FOREACH(tool gtar tar git)
  STRING(TOUPPER ${tool}  TOOL)

=== plugin/innodb_memcached/daemon_memcached/CMakeLists.txt ===
# Copyright (c) 2011, 2018, Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

# Common defines and includes
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include
		    ${CMAKE_SOURCE_DIR}/sql
		    ${CMAKE_SOURCE_DIR}/bld/include
		    ${CMAKE_SOURCE_DIR}/regex
		    ${CMAKE_SOURCE_DIR}/libevent
		    ${CMAKE_SOURCE_DIR}/include/mysql
		    ${CMAKE_C_IMPLICIT_LINK_DIRECTORIES}
		    ${CMAKE_SOURCE_DIR}/plugin/innodb_memcached/daemon_memcached/include
		    ${CMAKE_SOURCE_DIR}/plugin/innodb_memcached/daemon_memcached/include/memcached
		    ${CMAKE_SOURCE_DIR}/plugin/innodb_memcached/daemon_memcached

		)

INCLUDE_DIRECTORIES(SYSTEM ${LIBEVENT_INCLUDE_DIRS})

SET(CMAKE_CPP_FLAGS "${CMAKE_CPP_FLAGS} ${CMAKE_SHARED_LIBRARY_C_FLAGS} -I${CMAKE_SOURCE_DIR}/plugin/innodb_memcached/daemon_memcached/utilities")

# Remove "-Wdeclaration-after-statement" and "-Wvla" flags if exist to reduce the number of warnings
STRING(REGEX REPLACE "-Wdeclaration-after-statement" "" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
STRING(REGEX REPLACE "-Wvla" "" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")

# Disable "-Wunused-parameter -Wsign-compare -Wmissing-field-initializers -Wunused-but-set-variable" flags
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${CMAKE_SHARED_LIBRARY_C_FLAGS} -Wno-unused-parameter -Wno-sign-compare -Wno-missing-field-initializers -std=gnu99")
MY_CHECK_C_COMPILER_FLAG("-Wunused-but-set-variable" HAVE_UNUSET_BUT_SET_VARIABLE) # Requires GCC 4.5+
IF(HAVE_UNUSET_BUT_SET_VARIABLE)
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-but-set-variable")
ENDIF()

SET(LIBMEMCACHED_UTILITIES_SOURCES
		include/memcached/config_parser.h
		include/memcached/genhash.h
		include/memcached/util.h
		utilities/config_parser.c
		utilities/engine_loader.c
		utilities/engine_loader.h
		utilities/extension_loggers.c
		utilities/genhash.c
		utilities/genhash_int.h
		utilities/util.c)

ADD_LIBRARY(memcached_utilities STATIC ${LIBMEMCACHED_UTILITIES_SOURCES})

SET(CMAKE_CPP_FLAGS "${CMAKE_CPP_FLAGS} ${CMAKE_SHARED_LIBRARY_C_FLAGS} -I${CMAKE_SOURCE_DIR}/plugin/innodb_memcached/daemon_memcached/daemon")

SET(MEMCACHED_SOURCES
		daemon/memcached_mysql.h
		daemon/memcached_mysql.cc
		daemon/cache.h
		daemon/cache.c
		config_static.h
		daemon/daemon.c
		daemon/hash.c
		daemon/hash.h
		daemon/memcached.c
		daemon/memcached.h
		daemon/sasl_defs.c
		daemon/sasl_defs.h
		daemon/stats.c
		daemon/stats.h
		daemon/thread.c
		daemon/topkeys.c
		daemon/topkeys.h
		trace.h)

MYSQL_ADD_PLUGIN(libmemcached ${MEMCACHED_SOURCES}
		MODULE_ONLY MODULE_OUTPUT_NAME "libmemcached")

TARGET_LINK_LIBRARIES(libmemcached ${LIBEVENT_LIBRARY} ${LIBEVENT_LIBRARIES})
TARGET_LINK_LIBRARIES(libmemcached memcached_utilities)

IF(ENABLE_MEMCACHED_SASL)
  TARGET_LINK_LIBRARIES(libmemcached sasl2)
ENDIF()

## percona-xtradb-cluster-5.6 5.6.44-28.34

=== debian/changelog ===
percona-xtradb-cluster-5.6 (5.6.44-28.34-1) unstable; urgency=medium

  * Update to new upstream release Percona XtraDB Cluster 5.6.44-rel86.0-
    28.34

 -- Percona Jenkins <jenkins@os-jessie-32-template>  Wed, 19 Jun 2019 08:17:10 -0400

percona-xtradb-cluster-5.6 (5.6.44-rel86.0) unstable; urgency=low

  * Packaging updates for PXC 5.6.

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Sun, 15 Feb 2015 08:28:27 +0200

=== debian/control ===
--- 
+++ 
@@ -158,7 +158,7 @@
          psmisc,
          passwd,
          lsb-base (>= 3.0-10),
-         percona-xtradb-cluster-galera-3 (= 3.32-1),
+         percona-xtradb-cluster-galera-3 (= 3.34-1),
          percona-xtrabackup (>= 2.2.5),
          socat,
         lsof,
@@ -222,7 +222,7 @@
          psmisc,
          passwd,
          lsb-base (>= 3.0-10),
-         percona-xtradb-cluster-galera-3 (= 3.32-1),
+         percona-xtradb-cluster-galera-3 (= 3.34-1),
          percona-xtrabackup (>= 2.2.5),
          socat,
          lsof,
@@ -241,14 +241,14 @@
 Package: percona-xtradb-cluster-56
 Section: database
 Architecture: any
-Depends: percona-xtradb-cluster-server-5.6 (>= ${source:Version}), percona-xtradb-cluster-client-5.6 (>= ${source:Version}), percona-xtradb-cluster-galera-3 (= 3.32-1), ${misc:Depends}
+Depends: percona-xtradb-cluster-server-5.6 (>= ${source:Version}), percona-xtradb-cluster-client-5.6 (>= ${source:Version}), percona-xtradb-cluster-galera-3 (= 3.34-1), ${misc:Depends}
 Description: Percona XtraDB Cluster with Galera
  This is a meta-package providing PXC56 server, client and galera-3.
 
 Package: percona-xtradb-cluster-full-56
 Section: database
 Architecture: any
-Depends: percona-xtradb-cluster-server-5.6 (>= ${source:Version}), percona-xtradb-cluster-client-5.6 (>= ${source:Version}), percona-xtradb-cluster-galera-3 (= 3.32-1), percona-xtradb-cluster-test-5.6 (>= ${source:Version}), percona-xtradb-cluster-5.6-dbg (>= ${binary:Version}),  percona-xtradb-cluster-garbd-3 (= 3.32-1), percona-xtradb-cluster-galera3-dbg (= 3.32-1), percona-xtradb-cluster-server-debug-5.6, ${misc:Depends}
+Depends: percona-xtradb-cluster-server-5.6 (>= ${source:Version}), percona-xtradb-cluster-client-5.6 (>= ${source:Version}), percona-xtradb-cluster-galera-3 (= 3.34-1), percona-xtradb-cluster-test-5.6 (>= ${source:Version}), percona-xtradb-cluster-5.6-dbg (>= ${binary:Version}),  percona-xtradb-cluster-garbd-3 (= 3.34-1), percona-xtradb-cluster-galera3-dbg (= 3.34-1), percona-xtradb-cluster-server-debug-5.6, ${misc:Depends}
 Description: Percona XtraDB Cluster with Galera
  This is a meta-package providing PXC56 server, client, galera-3, test and debug packages.

=== debian/rules ===
--- 
+++ 
@@ -30,9 +30,9 @@
 
 DISTRIBUTION = $(shell lsb_release -i -s)
 
-wsrep_version="28.32"
-percona_server_version="84.3"
-revision="e2908fe"
+wsrep_version="28.34"
+percona_server_version="86.0"
+revision="4b3e224"
 compilation_comment_debug="Percona XtraDB Cluster - Debug (GPL), Release rel$(percona_server_version), Revision $(revision), WSREP version $(wsrep_version)"
 compilation_comment_release="Percona XtraDB Cluster (GPL), Release rel$(percona_server_version), Revision $(revision), WSREP version $(wsrep_version)"
 server_suffix="-56"
